<template>
  <div class="taskListBox">
    <el-form class="task-main" label-width="70px">
      <el-form-item label="航线选择">
        <el-select v-model="selectedAirwayId">
          <el-option v-for="(item , i) in airwayList" :label="item.name" :value="item.id"></el-option>
        </el-select>
      </el-form-item>
      <div class="btn" @click="onStartTask" v-hover>一键任务</div>
      <div class>
        <span class="btn__add-line" @click="showAirwayEdit = true">
          <span class="f8"></span> 创建航线
        </span>
      </div>
    </el-form>
    <AirwayEdit v-if="showAirwayEdit" @close="showAirwayEdit = false" @addDone="getAirwayList"></AirwayEdit>
  </div>
</template>
<script>
import { Utils } from "../../../../../../../../../../lib/cesium";
import { mapState, mapActions } from "vuex";
import { Control_API } from "../../../../../../../../../../api";
import AirwayEdit from "./components/airwayEdit";

const airwayEntities = []; // 航线实体
let point_entity = null;

export default {
  name: "taskList",
  components: { AirwayEdit },
  props: {},
  inject: ["rootNode", "bus"],
  data() {
    return {
      //航线列表
      airwayList: [],
      // 选择的航线
      selectedAirwayId: "",
    };
  },
  computed: {
    ...mapState("MMCFlightControlCenter", ["cesiumViewer", "useSTLAirway"]),
    ...mapState("MMCFlightControlCenter/uav", ["uav"]),
    ...mapState("MMCFlightControlCenter/hangar", ["hangar"]),
    showAirwayEdit: {
      get() {
        return this.$store.state.MMCFlightControlCenter.showAirwayEdit;
      },
      set(value) {
        this.$store.commit("MMCFlightControlCenter/setState", {
          key: "showAirwayEdit",
          value,
        });
      },
    },
    // 选择的航线
    selectedAirway() {
      let find = this.airwayList.find((item) => {
        return item.id == this.selectedAirwayId;
      });
      if (find) {
        return find;
      } else {
        return {
          name: "",
          id: -1,
        };
      }
    },
  },
  watch: {
    selectedAirway() {
      this.clearAirwayEntities();
      if (this.selectedAirway.id !== -1) {
        try {
          let airway = this.selectedAirway.content;
          this.createAirwayEntities({
            polyline: airway,
            id: airway.id,
          });
        } catch (e) {
          console.log("绘制航线失败", e);
        }
      }
    },
  },
  async created() {
    this.bus.$on("startTask", this.onStartTask);
    /* if (this.useSTLAirway) {
      let res = await Control_API.getUavRouteList({
        pageNo: 1,
        pageSize: 100,
        nestId: this.hangar.id,
      });
      if (res?.code === 0) {
        let airwayList = [];
        for (let i = 0; i < res.data.list.length; i++) {
          let item = res.data.list[i];
          let flightCourseJson;
          try {
            flightCourseJson = JSON.parse(item.flightCourseJson);
          } catch (e) {
            console.log(e);
          }
          // 转换成飞控中心能接受的数据协议
          let content = flightCourseJson
            ? await this.$store.dispatch(
                "MMCFlightControlCenter/apiPointsToFKZXPoints",
                {
                  list: flightCourseJson?.linePointSaveReqVOS || [],
                  actionListKey: "pointActionSaveReqVOS",
                }
              )
            : null;
          airwayList.push({
            name: item.flightName,
            id: item.id,
            content: content,
          });
        }
        this.airwayList = airwayList;
      }
    } else {
      this.rootNode.$emit("airwayListGet", {
        pageNo: this.airwayData.pageNo,
        pageSize: this.airwayData.pageSize,
        callback: (data) => {
          this.airwayList = airwayData?.records || [];
        },
      });
    } */
    this.getAirwayList();
  },
  beforeDestroy() {
    this.clearAirwayEntities();
  },
  methods: {
    ...mapActions("MMCFlightControlCenter", [
      "createAirwayEntities",
      "clearAirwayEntities",
      "apiPointsToFKZXPoints",
    ]),
    ...mapActions("MMCFlightControlCenter/uav", ["isTakeOver"]),
    /**
     * 更新任务列表
     */
    getAirwayList(id) {
      console.log("getAirwayList", this.taskListAll);
      this.rootNode.$emit("airwayListGet", {
        pageNo: 1,
        pageSize: 100,
        hangar: this.hangar,
        callback: (res) => {
          this.airwayList = res?.records || [];
          this.$nextTick(() => {
            if (id) {
              this.selectedAirwayId = id;
            }
          });
        },
      });
    },
    /**
     * 一键任务事件
     */
    async onStartTask() {
      // 判断是否已接管
      /* if (!(await this.isTakeOver())) {
        this.$message.warning("请先接管无人机");
        return;
      } */

      // 判断是否选择了航线
      if (this.selectedAirway.id === -1) {
        this.$message.warning("请选择航线");
        return;
      }
      try {
        await this.$confirm("请确认是否进行一键任务操作?", "安全确认", {
          cancelButtonText: "取消",
          confirmButtonText: "确定",
          customClass: "uav_controlPane",
          showClose: false,
        });
        this.$store.commit("MMCFlightControlCenter/hangar/setState", {
          key: "airlineData",
          value: this.selectedAirway,
        });
        this.$store.dispatch("MMCFlightControlCenter/hangar/takeOff", {
          callback: (status) => {
            if (status) {
              this.$message.success("一键任务指令发送成功");
            } else {
              this.$message.error("一键任务指令发送失败");
            }
          },
        });
        this.rootNode.$emit("taskStart", {
          uav: this.uav,
          task: this.selectedTask,
          airway: this.selectedAirway,
        });
      } catch (e) {}
    },
  },
};
</script>
<style lang="scss" scoped>
.taskListBox {
  height: 100%;
  width: 416px;
  background: #222222;
  border-radius: 12px;
  transition: 0.3s;
  display: flex;
  flex-direction: column;

  .header {
    flex-shrink: 0;
    display: flex;
    justify-content: space-between;
    height: 32px;
    background: #3c3c3c;
    border-radius: 12px 12px 0px 0px;
    .title {
      display: flex;
      align-items: center;
      margin-left: 10px;
      .font {
        font-size: 20px;
        font-family: YouSheBiaoTiHei;
        color: #14faff;
        line-height: 26px;
        text-shadow: 0px 1px 1px rgba(2, 32, 56, 0.2);
        background-image: -webkit-linear-gradient(
          right,
          #e3aa77,
          #f5cda9,
          #f9ecd3,
          #fcdbb1,
          #edb07a
        );
        -webkit-background-clip: text;
        -webkit-text-fill-color: transparent;
      }
    }
    .active {
      background-image: linear-gradient(
        180deg,
        #9198ff 0%,
        rgba(45, 81, 153, 0.22) 40%,
        #05091a 100%
      );
      border: 1px solid #70daf9;
      box-shadow: inset 0 0 10px 2px #3f9dff;
      font-family: MicrosoftYaHei-Bold;
      font-size: 14px;
      color: #70daf9;
      letter-spacing: 0;
      font-weight: 700;
    }

    .default {
      background-image: linear-gradient(
        180deg,
        #9198ff 0%,
        rgba(45, 81, 153, 0.22) 40%,
        #05091a 100%
      );
      border: 1px solid #70daf9;
      font-family: MicrosoftYaHei-Bold;
      font-size: 14px;
      color: rgba(112, 218, 249, 0.5);
      letter-spacing: 0;
      font-weight: 700;
    }
  }
  .task-main::v-deep {
    flex: auto;
    padding: 38px 16px 16px;
    position: relative;
    display: flex;
    flex-direction: column;

    .el-form-item__label {
      color: #fff;
    }

    .btn__add-line {
      position: absolute;
      bottom: 20px;
      right: 20px;
      font-size: 10px;
      color: #43deff;
      cursor: pointer;
    }

    .el-form-item {
      flex-grow: 1;
    }
  }

  .btn {
    width: 122px;
    height: 32px;
    text-align: center;
    line-height: 32px;
    margin: 0 auto;
    color: #fff;
    background: #3388ff;
    font-family: SourceHanSansCN, SourceHanSansCN;
    font-weight: 400;
    font-size: 14px;
    cursor: pointer;
  }
}
.select-airway__btn {
  width: 100%;
  height: 30px;
  padding: 0;
}
</style>
